/*
 * Copyright (c) 2014 F. Mannhardt (f.mannhardt@tue.nl)
 * 
 * LICENSE:
 * 
 * This code is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 3 of the License, or (at your option) any
 * later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */
package org.processmining.xeslite.external;

import org.deckfour.xes.model.XAttributeMap;

/**
 * @author F. Mannhardt
 * 
 */
final class XEventObservableCachingExternalImpl extends XEventCachingExternalImpl {

	interface CachedEventObserver {

		void setName(String name);

		void setTransition(String transition);

		void setTime(long time);

	}

	private CachedEventObserver observer;

	XEventObservableCachingExternalImpl(long id, XAttributeMap attributeMap, ExternalStore store) {
		super(id, attributeMap, store);
	}

	public void setName(String name) {
		super.setName(name);
		if (observer != null) {
			observer.setName(name);
		}
	}

	public void setTransition(String transition) {
		super.setTransition(transition);
		if (observer != null) {
			observer.setTransition(transition);
		}
	}

	public void setTime(long time) {
		super.setTime(time);
		if (observer != null) {
			observer.setTime(time);
		}
	}

	public CachedEventObserver getObserver() {
		return observer;
	}

	public void setObserver(CachedEventObserver observer) {
		this.observer = observer;
	}

}
